#ifndef MODULAR_MOD_TOOLS_H
#define MODULAR_MOD_TOOLS_H

// Please all developers of the WoC Project, add any enable/disable stuff from modules in here
// like the example shown below

/************************************************************************************************/
/* TGA_INDEXATION                          01/21/08                                MRGENIE      */
/*                                                                                              */
/* These numbers must correspond to the number of religions/corporations represented in the tga */
/************************************************************************************************/
#define TGA_RELIGIONS									GC.getTGA_RELIGIONS()
#define TGA_CORPORATIONS								GC.getTGA_CORPORATIONS()
/************************************************************************************************/
/* TGA_INDEXATION                          END                                                  */
/************************************************************************************************/
/************************************************************************************************/
/* MODULES                                 10/16/07                                MRGENIE      */
/*                                                                                              */
/*                                                                                              */
/************************************************************************************************/
// Dale - DCM: Globals START
//Battle Effects
#define	USE_BATTLE_EFFECTS								GC.isDCM_BATTLE_EFFECTS()

//DCM Combat
#define	USE_DCM_AIR_BOMBING								GC.isDCM_AIR_BOMBING()
#define	USE_DCM_RANGE_BOMBARD							GC.isDCM_RANGE_BOMBARD()
#define	USE_DCM_ATTACK_SUPPORT							GC.isDCM_ATTACK_SUPPORT()
#define	USE_DCM_STACK_ATTACK							GC.isDCM_STACK_ATTACK()
#define	USE_DCM_OPP_FIRE								GC.isDCM_OPP_FIRE()
#define	USE_DCM_ACTIVE_DEFENSE							GC.isDCM_ACTIVE_DEFENSE()
#define	USE_DCM_ARCHER_BOMBARD							GC.isDCM_ARCHER_BOMBARD()
#define	USE_DCM_FIGHTER_ENGAGE							GC.isDCM_FIGHTER_ENGAGE()
// Dale - DCM: Globals END

//Game Options
#define USE_BARBARIAN_WORLD								GC.getGameINLINE().isOption(BARBARIAN_WORLD)													// BARBARIAN_WORLD
#define USE_REVOLUTION_MOD								!(GC.getGameINLINE().isOption(GAMEOPTION_NO_REVOLUTION))														// REVOLUTION_MOD
#define USE_LIMITED_RELIGIONS							GC.getGameINLINE().isOption(GAMEOPTION_LIMITED_RELIGIONS)														// LIMITED_RELIGIONS
#define USE_INQUISITIONS								!(GC.getGameINLINE().isOption(GAMEOPTION_NO_INQUISITIONS))													// INQUISITIONS_MOD
#define USE_BARBARIAN_CIV								!(GC.getGameINLINE().isOption(GAMEOPTION_NO_BARBARIAN_CIV))															// BARBARIAN_CIV
#define USE_TECH_DIFFUSION								!(GC.getGameINLINE().isOption(GAMEOPTION_NO_TECH_DIFFUSION))														// TECH_DIFFUSION
#define USE_START_AS_MINORS								GC.getGameINLINE().isOption(GAMEOPTION_START_AS_MINORS)														// START_AS_MINORS
#define USE_RUTHLESS_AI									GC.getGameINLINE().isOption(GAMEOPTION_RUTHLESS_AI)														// RUTHLESS_AI

//RevDCM Mod Components
#define USE_DYNAMIC_CIV_NAMES							GC.isDYNAMIC_CIV_NAMES()													// DYNAMIC_CIV_NAMES
#define USE_DYNAMIC_RELIGION_SPREAD						GC.isDYNAMIC_RELIGION_SPREAD()													// DYNAMIC_RELIGION_SPREAD
#define USE_INFLUENCE_DRIVEN_WAR						GC.isIDW_ENABLED()                                           // Influence Driven War
#define USE_SUPER_SPIES									GC.isSS_ENABLED()                                           // Super Spies additions

/************************************************************************************************/
/* MODULES                                 END	                                                */
/************************************************************************************************/
#define OWNERSHIP_INFO_WIP 1
#define DEBUG_TGA_INDEX 1

#endif // ifndef MODULAR_MOD_TOOLS_H
